# ARST打卡第234周[234/521]

<!--more-->

## Algorithm
lc274_H指数

思路: 
感觉就是先排序，然后倒序模拟查看至少有i篇论文被引用 `citations[i]` 次.
当前ans就是 `min(i, citations[i])`

```cpp
class Solution {
public:
    int hIndex(vector<int>& citations) {
        int sz = citations.size();
        int ans = 0;
        sort(citations.begin(), citations.end());
        for (int i = sz - 1; i >= 0; i--) {
            int index = sz - i;
            ans = max(ans, min(citations[i], index));
            if (citations[i] < index) {
                break;
            }
        }
        return ans;
    }
};
```

发现[题解](https://leetcode.cn/problems/h-index/solutions/869042/h-zhi-shu-by-leetcode-solution-fnhl/?envType=daily-question&envId=2023-10-29) 还有二分，计算等方法。

其中二分和排序时间复杂度一样，但是二分的空间复杂度好一点点，计数则只需要O(n),通过计数模拟得到。

```cpp
class Solution {
public:
    int hIndex(vector<int>& citations) {
        int n = citations.size(), tot = 0;
        vector<int> counter(n + 1);
        for (int i = 0; i < n; i++) {
            if (citations[i] >= n) {
                counter[n]++;
            } else {
                counter[citations[i]]++;
            }
        }
        for (int i = n; i >= 0; i--) {
            tot += counter[i];
            if (tot >= i) {
                return i;
            }
        }
        return 0;
    }
};
// 链接：https://leetcode.cn/problems/h-index/
```

## Review
【TED演讲】工作不是你的家庭

<div align = "center">
    <iframe  width="100%" height="700" src="//player.bilibili.com/player.html?aid=832520857&bvid=BV1E34y1u75p&cid=1309100434&p=1" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
</div>

建立工作边界，防止过度劳累导致丧失工作热情，从而过一个比较好的细水长流的工作和生活。

## Tips
[Rocksdb Iterator实现：从DBIter 到 TwoLevelIter 的漫长链路](https://blog.csdn.net/Z_Stand/article/details/111712716)

## Share
[perf-example website share](https://www.brendangregg.com/perf.html)

这个网站的内容非常清晰，一张框架图更是一图胜千言，所以分享推荐。

